


CMIX(CMIX-2)        UNIX Programmer's Manual         CMIX(CMIX-2)



NAME
     Global data entry commands available in Cmix

     input("file_name",[cmix_unit_number])
          Open input file "file_name" with write protection.
          Unit number defaults to 0.  Cmix units must be opened
          in numerical order.  Once opened a Cmix unit may be
          redefined arbitrarily by opening a different file with
          the same unit_number.  This will effectively close the
          current file.

     output("file_name",[cmix_unit_numbers])
          Open output file "file_name" with no write protection.
          Unit number defaults to 1.

     makegen(location[starts with1], gen_number, size,
     gen_args..)
          Load gen_array 'location' according to the rules of
          routine 'gen_number' with size 'size'.

     open("file_name",cmix_unit_number,read/write_flag)
          Open file "file_name" with cmix 'cmix_unit_number' and
          read/write_flag as in standard Unix open call.

     peakoff(cmix_unit_number)
          Turn off checking for peak amplitudes on specified
          unit.

     punch(cmix_unit_number,resultant_amp,channel0?,..channel3?)
          Turn on facility to produce normalization cards for
          specified unit, with 'resultant_amp', for channels
          specified with positive value.

     sfclean(cmix_unit_number,[start_time],[duration],[channel0?,..channel3?])
          Erase signal on specified unit, starting at
          'start_time' for 'duration', on channels specified by
          positive value.

     sfcopy(in_cmix_unit_number,out_cmix_unit_number,in_skip,out_skip,dur)
          Copy input file to output file with specified skips for
          'dur'.  Specifications (sr, nchans, class) of files
          must match.

     sfprint(cmix_unit_number)
          Print header info for specified unit.

     system("any_system_call")
          Perform system call.

     ampdb(amp_in_db)
          returns, to Minc, amplitude from decibel specification.




Printed 9/7/88                                                  1






CMIX(CMIX-2)        UNIX Programmer's Manual         CMIX(CMIX-2)



     dbamp(amp_in_abs_value)
          returns, to Minc, decibels from amplitude specifica-
          tion.

     octcps(cps)
          Return, to Minc, linear octave value from cps.

     srand(seed)
          Seed, with val between 0 and 1, random() and rand().

     fplot(gen_number)
          Draw picture of array 'gen_number', created by mak-
          egen().

     tb(beat)
          Convert beat to time according to current tempo card.

     bt(time)
          Convert time to beat according to current tempo card.

     tbase(time_base)
          Set base for tempo, normally set to 60. I.e., beats per

     tempo(beat1,tempo1,beat2,tempo2..beatn,tempon)
          Draw tempo curve and put it into effect.

     cpsoct(oct)
          Return, to Minc, cps, from linear octave value.

     random()
          Return, to Minc, random number between 0 and 1.

     cpspch(pch)
          Return, to Minc, cps from 8ve.pch form.

     pchcps(cps)
          Return, to Minc, pch from cps.

     rand()
          Return, to Minc, random number between -1 and +1.

     trunc(value)
          Return, to Minc, integer portion of 'value'.


DESCRIPTION
     These are all of the commands, with the exception of user-
     defined calls, that are loaded in the Cmix module.  These
     are not to be confused with the calls and routines that are
     available in the construction of user-written routines.
     Some of the above result in a specified action on a sound-
     file, while others merely return value which can be used in



Printed 9/7/88                                                  2






CMIX(CMIX-2)        UNIX Programmer's Manual         CMIX(CMIX-2)



     Minc.

SEE ALSO
     Minc, makegen, usersub, tempo, sfcreate, units.



















































Printed 9/7/88                                                  3



